/* THIS FILE IS AUTOGENERATED FROM SpeechRecognitionEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_SpeechRecognitionEventBinding_h
#define mozilla_dom_SpeechRecognitionEventBinding_h

#include "EventBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/SpeechRecognitionResultList.h"
#include "nsIDocument.h"

class nsIDocument;

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class ProtoAndIfaceCache;
class SpeechRecognitionEvent;
struct SpeechRecognitionEventAtoms;
struct SpeechRecognitionEventInitAtoms;
class SpeechRecognitionResultList;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

struct SpeechRecognitionEventInit : public EventInit
{
  RefPtr<nsIDocument> mEmma;
  JS::Value mInterpretation;
  uint32_t mResultIndex;
  RefPtr<mozilla::dom::SpeechRecognitionResultList> mResults;

  SpeechRecognitionEventInit();

  explicit inline SpeechRecognitionEventInit(const FastDictionaryInitializer& )
    : EventInit(FastDictionaryInitializer()),
      mInterpretation(JS::UndefinedValue())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  SpeechRecognitionEventInit(const SpeechRecognitionEventInit&) = delete;
  void operator=(const SpeechRecognitionEventInit) = delete;

  static bool
  InitIds(JSContext* cx, SpeechRecognitionEventInitAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastSpeechRecognitionEventInit : public SpeechRecognitionEventInit
{
  inline FastSpeechRecognitionEventInit()
    : SpeechRecognitionEventInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace SpeechRecognitionEventBinding {

  typedef mozilla::dom::SpeechRecognitionEvent NativeType;

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::SpeechRecognitionEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal);

} // namespace SpeechRecognitionEventBinding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_SpeechRecognitionEventBinding_h
